module Help(bugMsg, helpTable, usageHeader, usageTrailer) where

import GenUtil(buildTableRL)

{-# NOINLINE usageHeader #-}
{-# NOINLINE usageTrailer #-}
{-# NOINLINE bugMsg #-}
{-# NOINLINE helpTable #-}

usageHeader :: String
usageTrailer :: String
bugMsg :: String
helpTable :: String

usageHeader = "Usage: ginsu [OPTION...] categories..."

usageTrailer = unlines [
    "\nTo get started, generate a configuration file using the following command:",
    "   mkdir ~/.gale ; ginsu -s > ~/.gale/ginsu.config",
    "Edit the configuration file and run ginsu!",
    "",
    "The homepage is at:",
    "   <http://repetae.net/john/computer/ginsu/>",
    "To report a bug go to:",
    "   <http://bugs.ofb.net/cgi-bin/bugzilla/enter_bug.cgi?product=Ginsu>",
    "When reporting a bug, include the last few lines of ~/.gale/ginsu.errorlog if it seems appropriate."
    ]

bugMsg = unlines [
    "There has been an internal error",
    "verify the output of ginsu --checkconfig and",
    "please inform <john@ugcs.caltech.edu> or file a bug report at",
    "<http://bugs.ofb.net/cgi-bin/bugzilla/enter_bug.cgi?product=Ginsu>",
    "Include the following text in any error report:"
    ]


helpTable = unlines $ buildTableRL [
    ("Keys:", ""),
    ("F1", "Help Screen"),
    ("F2", "Main Screen"),
    ("F3", "Presence Status Screen"),
    ("",""),
    ("j","next puff"),
    ("k","previous puff"),
    ("G","last puff"),
    ("g","first puff"),
    ("<Enter> C-E","forward one line"),
    ("<BackSpace> C-Y","back one line"),
    ("C-F <PgDown>","forward one page"),
    ("C-B <PgUp>","back one page"),
    ("C-D","forward one half-page"),
    ("C-U","back one half-page"),
    ("",""),
    ("d","Show puff details"),
    ("",""),
    ("c ~","add new filter"),
    ("u","pop one filter"),
    ("U","pop all filters"),
    ("!","invert filter at top of stack"),
    ("x","swap top two filters on stack"),
    ("a","filter to current author"),
    ("t","filter to current thread"),
    ("T","filter to strict thread"),
    ("m[1-9]","set mark - save current filter stack at given key"),
    ("[1-9]","recall filter stack saved here with 'm'"),
    ("",""),
    ("f","follow-up to category"),
    ("p","compose new puff"),
    ("r","reply to author"),
    ("N","modify presence string"),
    ("",""),
    ("^R","reconnect to all servers"),
    ("E","edit and reload configuration file"),
    ("q Q","quit program"),
    ("^L","redraw screen"),
    ("",""),
    ("Filters:",""),
    ("~a","author"),
    ("~c","category"),
    ("~i","case insensitive substring search"),
    ("~k","keyword"),
    ("~s","puffers real name"),
    ("~t","thread - transitive closure of categories"),
    ("(default)","substring search")
    ]
