module KeyName(stringToKeys, keyCanon ,keysToString, showKeyInfo) where

import Screen(Key(..))
import Char
import List
import GenUtil



stringToKeys :: String -> [Key]
stringToKeys "" = []
stringToKeys ('<':cs) = let (n,r) = span (/= '>') cs in
     case lookup ((map toLower $ filter (not . isSpace) n)) ftl of
	Just k -> k
	Nothing -> KeyUnknown 0 
      : stringToKeys (drop 1 r)
stringToKeys (c:cs) = KeyChar c : stringToKeys cs


namedKeyTableInt = [
    ("NUL",0),
    ("BackSpace",8),
    ("BS",8),
    ("Tab",9),
    ("Enter",13),
    ("Enter",10),
    ("NL",10),
    ("FF",12),
    ("CR",13),
    ("Return",13),
    ("ESC",27),
    ("Space",32),
    ("LT",60),
    ("Bslash",92),
    ("BackSlash",92),
    ("Bar",124),
    ("Backspace",127)
    ]

namedKeyTableKey = [
    ("Up",KeyUp),
    ("Down",KeyDown),
    ("Left",KeyLeft),
    ("Right",KeyRight),
    ("Help",KeyHelp),
    ("Undo",KeyUndo),
    ("Insert",KeyIC),
    ("Home",KeyHome),
    ("End",KeyEnd),
    ("PageUp",KeyPPage),
    ("PageDown",KeyNPage),
    ("Delete",KeyDC),
    ("Enter",KeyEnter),
    ("Print",KeyPrint),
    ("Backspace",KeyBackspace)
    ]


fTable = map (\n -> ('F':show n,KeyF n)) [0..31]

cTable = map (\n -> ("C-" ++ [chr (n + 64)], KeyChar (chr n))) [0..31]

ft,ftl :: [(String,Key)]
ft = fTable ++ namedKeyTableKey ++ map (\(x,y) -> (x, KeyChar (chr y))) namedKeyTableInt ++ cTable
ftl = map (\(x,y) -> (map toLower x,y)) ft

kg :: [[Key]]
kg = transitiveGroup $ map (snub . map snd) (groupBy (\(x,_) (y,_) -> x == y) 
	(sort ftl))

transitiveGroup :: Eq a => [[a]] -> [[a]]
transitiveGroup gs = tg [] gs where
    tg x [] = x
    tg gs (g:rg) = tg (f gs g) rg
    f [] g = [g]
    f (x:xs) g | isConjoint g x = nub (x ++ g):xs
    f (x:xs) g = x:f xs g

showKeyInfo :: String
showKeyInfo = unlines $ (buildTableRL $ map (\(x,y) -> (x,show y)) ft) ++ (map show kg)
    

keyCanon :: Key -> Key
keyCanon k | ((y:_):_) <- [z| z <- kg, k `elem` z] = y
keyCanon k = k

keysToString ks = concatMap ck ks where
    ck c | (x:_) <- [n| (n,k) <- ft, k == c] = '<' : (x ++ ">")
    ck (KeyChar c) = [c]
    ck k = "<KeyUnknown:" ++ show k ++ ">"

